
local addLootCurrent = 1

local _init_finalize_original = GageAssignmentManager.init_finalize
function GageAssignmentManager:init_finalize()
	local currentJob = managers.job:current_level_id()
	log("current level is " .. currentJob)
	
	GageAssignmentManager.dozerLoot = nil
	
	if Network:is_server() and managers.money:offshore() > 300000000 and (Global.game_settings.difficulty == "overkill_290"
		or Global.game_settings.difficulty == "easy_wish" or Global.game_settings.difficulty == "sm_wish")
	then
		local file = io.open("mods/Gage loot courier/heists/" .. currentJob .. ".json", "r")
		local data
		if file then
			local temp = file:read("*all")
			file:close()

			data = json.decode(temp)
		end

		file = io.open("mods/Gage loot courier/dozer.json", "r")
		local dozerData
		if file then
			local temp = file:read("*all")
			file:close()

			dozerData = json.decode(temp)
		end

		if data and data.addLootOptions then

			if dozerData and dozerData.dozerSpawnsLoot and dozerData.dozerHeists then
				if dozerData.dozerHeists[1] == "_all" then
					GageAssignmentManager.dozerLoot = data.addLootOptions
					GageAssignmentManager.dozerLootChance = dozerData.chance or 1
				else
					local i = 1
					while i <= #dozerData.dozerHeists do
						if currentJob == dozerData.dozerHeists[i] then
							GageAssignmentManager.dozerLoot = data.addLootOptions
							GageAssignmentManager.dozerLootChance = dozerData.chance or 1
							break
						end
						i = i + 1
					end
				end
			end

			if data.spawnMoreLoot and data.addPositions then
				local unitRotation = Vector3(0, 0, 0)
				local unitNamesPos = 1
				local currentUnit
				
				if data.maxStep == nil then
					data.maxStep = 2
				end

				local num = math.random(data.maxStep)
				while num <= #data.addPositions do
					local curPos = Vector3(data.addPositions[num][1], data.addPositions[num][2], data.addPositions[num][3])

					currentUnit = World:spawn_unit(Idstring(data.addLootOptions[unitNamesPos]), curPos, unitRotation)
					currentUnit:interaction():set_active(true, true)

					if unitNamesPos < #data.addLootOptions then
						unitNamesPos = unitNamesPos + 1
					else unitNamesPos = 1 end
					num = num + math.random(data.maxStep)
				end
			end
			if data.replaceGagePacks then
				self.addLootOptions = data.addLootOptions
			end
		end
	end
	_init_finalize_original(self)
end

local _do_spawn_original = GageAssignmentManager.do_spawn
function GageAssignmentManager:do_spawn(position, rotation)
	if not self.addLootOptions then
		_do_spawn_original(self, position, rotation)
	else
		local mytemp = World:spawn_unit(Idstring(self.addLootOptions[addLootCurrent]), position, rotation)
		if mytemp and mytemp:interaction() then
			mytemp:interaction():set_active(true, true)
		end

			if addLootCurrent < #self.addLootOptions then
				addLootCurrent = addLootCurrent + 1
			else addLootCurrent = 1 end

		return nil
	end
	return nil
end
